Page MenuHomeFreeBSD

iflib: fix dangling device softc pointer
ClosedPublic

Authored by jacob.e.keller_intel.com on Jul 19 2019, 10:44 PM.

Details

Summary

If a driver's IFDI_ATTACH_PRE function fails, the iflib_device_register
function will free the ctx pointer. However, it does not reset the
device softc pointer to NULL.

This will result in memory corruption as a future access to the now
invalid pointer will corrupt memory that is later allocated on top of
the same memory location.

The iflib_device_deregister function correctly resets the softc pointer
by using device_set_softc().

This clears up the invalid dangling pointer and prevents memory
corruption that could lead to a panic or undefined behavior if the
device's driver failed to attach.

Signed-off-by: Jacob Keller <jacob.e.keller@intel.com>

Test Plan

This fixes memory corruption that can lead to system instability and panics
if a device driver fails to attach. Ideally we should backport this into
both STABLE-11 and STABLE-12

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

erj accepted this revision as: erj.Jul 23 2019, 5:44 PM
gallatin accepted this revision.Jul 24 2019, 8:48 PM
This revision is now accepted and ready to land.Jul 24 2019, 8:48 PM
This revision was automatically updated to reflect the committed changes.